<template>
 <main id="bodySearch">

     <div class="container">
         <div class="row">
             <div class="block-entete col-md-12">
                 <div class=" text-center title">
                     <h1 v-html="$t('recherche.title')"></h1>
                 </div>

                 <div class="text-center subtitle">
                     <h2><span v-html="$t('recherche.subtitle')"></span></h2>
                 </div>
             </div>

             <div class="block-body col-md-12">
                <rechercheVille @change="updateCart" />

                <div class="content-search" ref="resultats" @scroll="onScroll" @touch="onScroll">
                     <ul>
                         <li v-for="(ville, index) in villes" v-bind:key="index">
                             <router-link :to="{ name: 'simulateur', params: { insee: ville.Id_ville_insee } }">
                                 {{ ville.Nom_ville }} [{{ ville.Departement }}]
                             </router-link>
                         </li>
                     </ul>
                 </div>
             </div>
             <div class="col-md-12 mt-5 search-subtext">
                Ce service est proposé gratuitement par Débutant-e Accepté-e et Ikuzo. Il a une vocation pédagogique.<br/>
                <br/>
                Vos données personnelles ne sont pas collectées dans le cadre de l'applicatif. Vos simulations sont stockées uniquement dans votre navigateur.
                Nous collectons des statistiques de fréquentation de manière anonyme en utilisant le logiciel Matomo configuré dans le respect des recommandations de la CNIL.
             </div>
         </div>

     </div>

 </main>
</template>


<script>

import axios from 'axios'

import rechercheVille from '@/components/recherche/rechercheVille.vue'

export default {
    name: "home-global",
    data: () => {
        return {
            villes: [],
            CancelToken: null,
            url: process.env.VUE_APP_HOSTS,
            page: 0,
            value: null,
            isLoading: false,
            next: null,
            total: null
        }
    },
    components: {
        rechercheVille
    },
    methods: {
        updateCart: function(value){

            if(value.length > 0 && value != this.value){

                this.$refs.resultats.scrollTop = 0;

                this.page = 0;

                this.value = value;
                this.search(value);

            }
            else if(value.length == 0)
            {
                this.villes = [];
                this.value = '';
            }
        },
        search: async function (add = false) {

            if(this.CancelToken){
                this.CancelToken.cancel();
            }

            if(this.page == -1){
                return false;
            }

            this.CancelToken = axios.CancelToken.source();

            try {

                this.isLoading = true;

                await axios
                    .post(`${this.url}search/${this.value}`, {
                            page: this.page
                        },
                        {
                            cancelToken: this.CancelToken.token
                        }
                    )
                    .then(response => {
                        this.isLoading = false;

                        if(add == true){
                            this.villes = this.villes.concat(response.data.data);
                            this.page = response.data.nextPage;
                            this.total = response.data.total;
                        }
                        else{
                            this.villes = response.data.data;
                            this.page = response.data.nextPage;
                            this.total = response.data.total;
                        }
                    });

            } catch (err) {
                this.isLoading = false;
                this.isError = false;
            }
        },
        onScroll ({ target: { scrollTop, clientHeight, scrollHeight }}) {
            if(!this.isLoading){
                if (scrollTop + clientHeight >= scrollHeight) {

                  if(this.page != -1){
                    this.search(true);
                  }
                }
            }

        }
    }
};
</script>
